# Static Gallery Generator (couldn't think of a decent name yet)

A free, open-source tool to automatically generate a gallery of your art, to put up on your personal website. Automatically creates thumbnails, the JS and the HTML (which you can then edit further to your liking). The gallery at the core is [nanogallery2](https://nanogallery2.nanostudio.org/).

I wanted to make this dead simple to set up and use, but it's definitely not quite there yet.

## Requirements / Setup

1. Install [Python](https://www.python.org/downloads/), to run the scripts
2. Install [FFmpeg](https://ffmpeg.org/), to create the thumbnails
  -  (some good instructions for installing FFmpeg are available here: https://ultahost.com/knowledge-base/install-ffmpeg-on-windows/)
3. Install the dependencies (`pip install -r requirements.txt`)

## How to Use

1. Place images or videos in the `gallery/media/` folder
2. Run `1-generate-thumbnails-and-table.py`
3. (optional) Edit the newly created `gallery-items.csv` to add titles, descriptions and tags
4. Run `2-generate-gallery.py`
5. (This part will probably change as I figure out ways to make this more accessible)
   Upload the `gallery` folder to your neocities and edit `index.html` to your liking!

If you want to change settings for how the gallery looks and works, you can either make changes to `nanogallery2-config.json` before running the scripts or to `gallery/gallery.js` afterwards.  

A detailed list of all possible settings is available [here](https://nanogallery2.nanostudio.org/documentation.html).